/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.readers.medreaders.ReadDICOM;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Toolkit;
import org.visnow.vn.gui.events.FloatValueModificationEvent;
import org.visnow.vn.gui.events.FloatValueModificationListener;
import static org.apache.commons.math3.util.FastMath.*;

/**
 *
 * @author babor
 */
public class ReadProgressDialog extends javax.swing.JDialog implements FloatValueModificationListener
{

    private ReadDICOMCore core = null;

    /**
     * Creates new form ReadProgressDialog
     */
    public ReadProgressDialog(java.awt.Frame parent, boolean modal, ReadDICOMCore core)
    {
        super(parent, modal);
        this.core = core;
        core.addFloatValueModificationListener(this);
        initComponents();

        if (parent == null) {
            Point myL = new Point();
            Dimension myD = this.getSize();
            Dimension wD = Toolkit.getDefaultToolkit().getScreenSize();
            myL.x = (wD.width - myD.width) / 2;
            myL.y = (wD.height - myD.height) / 2;
            setLocation(myL);
        } else {
            Point myL = new Point();
            Point wL = parent.getLocation();
            Dimension myD = this.getSize();
            Dimension wD = parent.getSize();
            myL.x = wL.x + (wD.width - myD.width) / 2;
            myL.y = wL.y + (wD.height - myD.height) / 2;
            setLocation(myL);
        }

    }

    public void stop()
    {
        this.dispose();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Reading DICOM data...");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("Reading DICOM data...");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(15, 15, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        progressBar.setMaximumSize(new java.awt.Dimension(32767, 28));
        progressBar.setMinimumSize(new java.awt.Dimension(10, 28));
        progressBar.setPreferredSize(new java.awt.Dimension(148, 28));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(15, 15, 15, 15);
        getContentPane().add(progressBar, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
        CoreThread coreThread = new CoreThread(core);
        coreThread.start();
    }//GEN-LAST:event_formComponentShown

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JProgressBar progressBar;

    // End of variables declaration//GEN-END:variables
    public void floatValueChanged(FloatValueModificationEvent e)
    {
        if (e.getVal() <= 0.0f) {
            progressBar.setValue(progressBar.getMinimum());
        } else if (e.getVal() >= 1.0f) {
            progressBar.setValue(progressBar.getMaximum());
            this.dispose();
        } else {
            progressBar.setValue(round(e.getVal() * progressBar.getMaximum()));
        }
    }

}
